sequential.order.start <- function(d,m,mode="int",
                                   T=1000,N=1000)
  .Call("BNSL_SequentialSamplerStart",d,as.integer(m),
        match(mode,c("int","max","min")),as.numeric(T),as.integer(N),
        DUP=FALSE)

sequential.order.update <- function(W,d,m,mode="int",
                                   T=1000,N=1000)
  .Call("BNSL_SequentialResample",W,d,as.integer(m),
        match(mode,c("int","max","min")),as.numeric(T),as.integer(N),
        DUP=FALSE)


sequential.weight.matrix <- function(samples)
  .Call("BNSL_GetWeightMatrix",samples,DUP=FALSE)


