#include <Rinternals.h>

#define AD_NODE(VN,I)         VECTOR_ELT(VECTOR_ELT((VN),1),(I))
#define SET_AD_NODE(VN,I,VAL) SET_VECTOR_ELT(VECTOR_ELT((VN),1),(I),(VAL))
#define VN_NODE(AD,I)         AD_NODE(AD,I)
#define SET_VN_NODE(AD,I,VAL) SET_AD_NODE(AD,I,VAL)

SEXP allocVaryNode(int index,int adnodes,int mcv) {
  SEXP vn,i,adn;
  PROTECT(vn = allocVector(VECSXP,2));
  PROTECT(i  = allocVector(INTSXP,2));
  PROTECT(adn= allocVector(VECSXP,adnodes));
  INTEGER(i)[0] = index;
  INTEGER(i)[1] = mcv;
  SET_VECTOR_ELT(vn,0,i);
  SET_VECTOR_ELT(vn,1,adn);
  UNPROTECT(3);
  return vn;
}

SEXP allocADNode(int start,int count,int vnnodes) {
  SEXP adn,i,vn;
  PROTECT(adn = allocVector(VECSXP,2));
  PROTECT(i   = allocVector(INTSXP,2));
  PROTECT(vn  = allocVector(VECSXP,vnnodes));
  INTEGER(i)[0] = start;
  INTEGER(i)[1] = count;
  SET_VECTOR_ELT(adn,0,i);
  SET_VECTOR_ELT(adn,1,vn);
  UNPROTECT(3);
  return adn;
}


