#include "bitfield.h"

/**
 * Convert an R vector into a key structure for use with a lookup
 */
void Vec2Key(SEXP v,char *key,int kn) {
  int i,n = length(v);
  memset(key,0,sizeof(char)*kn); /* clear the key */
  for(i=0;i<n;i++)
    BIT_ON(key,(int)(REAL(v)[i]-1));
}
