#ifndef _h_eedb_
#define _h_eedb_

typedef struct {
  double H;
} *eesample;

typedef struct {
  DB_ENV   *env;		/* Shared environment for the chain */
  DB       *samples,*ring_ndx;	/* The ring index    */
  int       burnin;		/* Burn-in counter   */
  eesample *current;		/* Current position  */
  eesample *proposed;		/* Proposed position */

  int       sample_size;	/* Number of bytes each sample takes */
  void*     params;		/* Parameters for the sampler        */

} *ee_db_chain;

ee_db_chain(const char *filename);

#endif
