setMethod("show","landscape",function(object) {
  cat("Sample Range: ")
  cat(paste(range(object@score)))
  cat("\nEnergy Ring Partition: ");
  cat(paste(object@partition))
  cat("\nEnergy Ring Sizes: ")
  cat(paste(sapply(object@rings,length)))
  cat("\n")
})



landscape <- function(sample,partition,first=NULL,H=-Inf) {
  #If we haven't done anything yet
  if(is.null(sample)) return(NULL)
  first <- if(is.null(first)) sample@diag@burnin+1 else first
  partition = sort(as.numeric(partition))
                                        #Strip the -Inf from the partition list
  if(is.infinite(partition[1]))
    partition = partition[-1]
  .Call("BNSL_MakeLandscape",sample,partition,as.integer(first),as.numeric(H))
}
