feature.probs <- function(d,m,o,mode="int")
  .Call("BNSL_FeatureProbs",d,as.integer(m),o,
        match(mode,c("int","max","min")),DUP=FALSE)
score.features <- function(d,m,o,mode="int",weights=NULL)
	.Call("BNSL_ScoreFeatures",
		d,as.integer(m),o,
	        match(mode,c("int","max","min")),weights,DUP=FALSE)

score.order <- function(d,o,m,mode="int")
  .Call("BNSL_ScoreOrder",d,as.integer(o),
        as.integer(m),
        match(mode,c("int","max","min")),
        DUP=FALSE)
score.graph <- function(d,g)
  .Call("BNSL_ScoreStructure",d,edgeL(g))

score.feature <- function(d,o,m,
                          i,j,
                          mode="int")
  .Call("BNSL_EdgeProb",d,as.numeric(m),match(mode,c("int","max","min")),
        o,as.integer(i),as.integer(j))

