#include "combo.h"

void init_combo(int n,int k,int*combo) {
  int i;
  for(i=0;i<k;i++) combo[i] = i+1;
}
int next_combo(int n,int k,int*combo) {
  if(combo[0] < n-k+1) {
    int t,j = -1;
    do { j++; } while(j<k-1 && (combo[j+1] <= combo[j]+1));
    combo[j]++;
    for(t=0;t<j;t++) combo[t] = t+1;
    return 1;
  }
  return 0;
}

SEXP BNSL_Combo(SEXP N,SEXP K,SEXP S) {
  SEXP res,temp;
  int n = REAL(N)[0];
  int k = REAL(K)[0];
  int i,s = REAL(S)[0];
  
  PROTECT(res = allocVector(VECSXP,s));
  PROTECT(temp = allocVector(INTSXP,k));
  i=0;
  init_combo(n,k,INTEGER(temp));
  SET_VECTOR_ELT(res,i++,temp);
  UNPROTECT(1);
  PROTECT(temp = duplicate(temp));
  while(next_combo(n,k,INTEGER(temp))) {
    SET_VECTOR_ELT(res,i++,temp);
    UNPROTECT(1);
    PROTECT(temp = duplicate(temp));
  }
  /* SET_VECTOR_ELT(res,i++,temp);	*/
  UNPROTECT(2);
  return res;
}

