#ifndef _h_eesample_
#define _h_eesample_

typedef struct ee_info {
  int chains;			/* Number of chains */
  int index;			/* My partition index */
  double   T;			/* Temperature      */
  double   H;			/* Energy barrier   */
  double*  partition;		/* Energy partitions  */
  double*  scores;		/* Score listing    */
  SEXP     rings;		/* Population list for rings */
  SEXP     population;		/* Population */
} ee_ctx;

int  EquiEnergyInit(ee_ctx *ctx,SEXP X);
void ee_ChainDiagnostics(SEXP res,int accept_jump,int reject_jump,
			 int*accept_swap,int*reject_swap,int n,
			 int burnin);
#endif
