#include "perm.h"

#define iter_swap(X,Y) { \
    int t = perm[(X)]; \
    perm[(X)] = perm[(Y)]; \
    perm[(Y)] = t; \
  }
#define reverse(F,L) { \
    int i=(F),j=(L)-1; \
    while(i < j) { \
      int t = perm[i]; \
      perm[i] = perm[j]; \
      perm[j] = t; \
      i++;j--; \
    }\
  }
    

int next_perm(int*perm,int n) {
  int first,last,next;
  first = 0;last = next = n;
  if(first == last || first == --next) return 0;
  for(;;) {
    int next1 = next;
    if(perm[--next] < perm[next1]) {
      int mid = last;
      for(;!(perm[next]<perm[--mid]););
      iter_swap(next,mid);
      reverse(next1,last);
      return 1;
    }
    if(next == first) {
      reverse(first,last);
      return 0;
    }
  }
}
