#ifndef _h_pq_
#define _h_pq_

typedef struct _pq_node {
  struct pq_node *left,*right;
  char payload[0];
} *pq_node;

typedef struct _pq_tree {
  int n;
  int size;
  int (*cmp)(void*a,void*b);
} *pq_tree;

int tree_payload_size(pq_tree t);
int tree_size(pq_tree t);

void tree_insert(pq_tree t,void*key);

#endif
